<template>
  <crud-data-table-update
    :item="value"
    @onSave="onSave(value)"
    @emitTheValueBeforeEditOnClose="emitValueToParent"
  >
    {{ value | formatCurrency }}
    <template v-slot:dialog>
      <v-form
        ref="form"
        @submit.prevent
      >
        <money-text-field
          :value="value"
          @input="emitValueToParent"
        />
      </v-form>
    </template>
  </crud-data-table-update>
</template>

<script>
  import MoneyMixin from '@/mixins/money'

  export default {
    name: 'EditAmountDialog',
    mixins: [MoneyMixin],
    inheritAttrs: false,
    props: {
      value: String,
      itemId: {
        type: Number,
        required: true,
      },
    },
    methods: {
      onSave (amount) {
        if (this.$refs.form.validate()) {
          this.$store.dispatch('incomeAmounts/updateIncomeAmountItself', {
            ID: this.itemId,
            amount,
          })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
        }
      },
      emitValueToParent (event) {
        this.$emit('input', event)
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          updateSuccess: 'Valor atualizado com sucesso!',
          updateError: 'Ops... Algo deu errado ao tentar atualizar o valor. Por favor, tente novamente.',
        },
        'en-US': {
          updateSuccess: 'Amount successfully updated!',
          updateError: 'Oops... Something went wrong while trying to update the amount. Please try again.',
        },
      },
    },
  }
</script>
